/* Cyrillic Virtual (on-screen) keyboard - JavaScript file
   Copyright (c) 2005  Paul Gorodyansky
  
  Implementation: http://cuba.WinRus.com (http://WinRus.com/onscreen.htm)
     
  Author's site - "Cyrillic (Russian): instructions for Windows and Internet": 
  http://WinRus.com/
  
   
 *
 *  This is the first Vurtual Keyboard (that provides physical keyboard input)
 *  with a programming code suitable for all three browser brands:
 *  Internet Explorer, Opera and Mozilla - and now WebKit-based Chrome, Safari
 *
 *  That is, this code for such "on-the-fly" input/editing is *original* -
 *  both keyboard-based and mouse-based parts -
 *  I could not use any code of older Virtual Keyboards because their programming
 *  code was working only under Internet Explorer.
 *  Also older mouse-based Keyboards were not suitable for normal text input/editing -
 *  they placed a new letter only at the end of the text, thus no text
 *  editing/correction was possible.
 *
 */



var Netscape, MSIE, Opera, Unknown, NN1, NN2, Ffox=false;
var Win, Mac, Other;
var NetscapeVer, MSIEVer, OperaVer, NetscapeOK, AlertMsg;
var strOperaPos;
var WebKit, WebKitOK;
WebKit=false; WebKitOK=false;

var Br = "1";

// detect browser

Netscape = navigator.appName == "Netscape";
MSIE = navigator.appName == "Microsoft Internet Explorer";
Opera = navigator.userAgent.indexOf("Opera") > -1;

Unknown = !(Netscape || MSIE || Opera);

NetscapeOK = false;

// detect platform
var n;
Win = navigator.userAgent.indexOf("Win") > -1;
Mac = navigator.userAgent.indexOf("Mac") > -1;
Other = !(Win || Mac);

// now extract version numbers

if(Netscape)
{
  NetscapeVer = parseFloat(navigator.appVersion);
  if (NetscapeVer>4)
  {
    n = navigator.userAgent; 
           
    if (n.indexOf("Netscape/") != -1)
    {
       NN1 = n.substr(n.indexOf("Netscape/")+9);
       NN1 = parseFloat(NN1);
    }
    else
     if (n.indexOf("Mozilla") != -1) // Mozilla, Firefox, WebKit-based Chrome, Safari,...
     { 
       if (n.indexOf("rv:") != -1)  // Mozilla, Firefox
       {
         NN1 = n.substr(n.indexOf("rv:")+3); 
         NN1 = parseFloat(NN1); 
         if (NN1 >= "1.3") NetscapeOK = true;
       }  
       else  //WebKit - Chrome, Safari?
       {
         if (n.indexOf("WebKit") != -1)
         { 
            NN1 = n.substr(n.indexOf("WebKit")+7); 
            WebKit = true;
            NN1 = parseFloat(NN1); 
            if (NN1 >= 525) WebKitOK= true;
         }
       }
      } // Mozilla
  }
  
  if (NetscapeOK || WebKitOK)
  {
      Br="NN";    
      if (n.indexOf("Firefox") != -1) Ffox = true;
  }
}
else if(MSIE)
{
  n = navigator.userAgent;
  MSIEVer = n.substr(n.indexOf("MSIE ")+("MSIE ").length, 4);
  MSIEVer = parseFloat(MSIEVer); 
  // converts it into a floatint point number

  if(Opera)
  {
     strOperaPos = n.indexOf("Opera/"); // "Opera " or "Opera/"
     if (strOperaPos == -1)
       OperaVer = n.substr(n.indexOf("Opera ")+("Opera ").length, 4);
     else
       OperaVer = n.substr(strOperaPos + ("Opera/").length, 4);    
        
     OperaVer = parseFloat(OperaVer);
  }
  else
    Br = "IE";
}
else if(Opera)  // Opera does not identify itself as MSIE
{
  n = navigator.userAgent;
  strOperaPos = n.indexOf("Opera/"); // "Opera " or "Opera/"

  if (strOperaPos == -1)
      OperaVer = n.substr(n.indexOf("Opera ")+("Opera ").length, 4);
  else
      OperaVer = n.substr(strOperaPos + ("Opera/").length, 4);    
        
  OperaVer = parseFloat(OperaVer);        
}


////////////////////////

          
                   // MS Standard йцукен
  var KbdVariant30 = {
    "~": "Ё",
    "!": "!",    
    "@": "\"",
    "#": "№",
    "$": ";",
    "%": "%",
    "^": ":",
    "&": "?",
    "*": "*",
    "(": "(",
    ")": ")",
    "_": "_",
    "+": "+",
    
    "`": "ё",
    "1": "1",
    "2": "2",
    "3": "3",
    "4": "4",
    "5": "5",
    "6": "6",
    "7": "7",
    "8": "8",
    "9": "9",
    "0": "0",
    "-": "-",    
    "=": "=",    
    
    "Q": "Й",
    "W": "Ц",
    "E": "У",
    "R": "К",
    "T": "Е",
    "Y": "Н",
    "U": "Г",
    "I": "Ш",
    "O": "Щ",
    "P": "З",
    "{": "Х",
    "}": "Ъ",
    "|": "/",
    
    "q": "й",
    "w": "ц",
    "e": "у",
    "r": "к",
    "t": "е",
    "y": "н",
    "u": "г",
    "i": "ш",
    "o": "щ",
    "p": "з",
    "[": "х",
    "]": "ъ",
    "\\": "\\",
    
    "A": "Ф",
    "S": "Ы",
    "D": "В",
    "F": "А",
    "G": "П",
    "H": "Р",
    "J": "О",
    "K": "Л",
    "L": "Д",
    ":": "Ж",
    "\"": "Э",
    
    "a": "ф",
    "s": "ы",
    "d": "в",
    "f": "а",
    "g": "п",
    "h": "р",
    "j": "о",
    "k": "л",
    "l": "д",
    ";": "ж",
    "'": "э",
    
    "Z": "Я",
    "X": "Ч",
    "C": "С",
    "V": "М",
    "B": "И",
    "N": "Т",
    "M": "Ь",    
    "<": "Б",
    ">": "Ю",
    "?": ",",    
    
    "z": "я",
    "x": "ч",
    "c": "с",
    "v": "м",
    "b": "и",
    "n": "т",
    "m": "ь",    
    ",": "б",
    ".": "ю",
    "/": "."
  };          
  
                   // MS Typewriter йцукен
  var KbdVariant31 = {
    "~": "+",
    "!": "1",    
    "@": "2",
    "#": "3",
    "$": "4",
    "%": "5",
    "^": "6",
    "&": "7",
    "*": "8",
    "(": "9",
    ")": "0",
    "_": "=",
    "+": "\\",
    
    "`": "|",
    "1": "№",
    "2": "-",
    "3": "/",
    "4": "\"",
    "5": ":",
    "6": ",",
    "7": ".",
    "8": "_",
    "9": "?",
    "0": "%",
    "-": "!",    
    "=": ";",    
    
    "Q": "Й",
    "W": "Ц",
    "E": "У",
    "R": "К",
    "T": "Е",
    "Y": "Н",
    "U": "Г",
    "I": "Ш",
    "O": "Щ",
    "P": "З",
    "{": "Х",
    "}": "Ъ",
    "|": "(",
    
    "q": "й",
    "w": "ц",
    "e": "у",
    "r": "к",
    "t": "е",
    "y": "н",
    "u": "г",
    "i": "ш",
    "o": "щ",
    "p": "з",
    "[": "х",
    "]": "ъ",
    "\\": ")",
    
    "A": "Ф",
    "S": "Ы",
    "D": "В",
    "F": "А",
    "G": "П",
    "H": "Р",
    "J": "О",
    "K": "Л",
    "L": "Д",
    ":": "Ж",
    "\"": "Э",
    
    "a": "ф",
    "s": "ы",
    "d": "в",
    "f": "а",
    "g": "п",
    "h": "р",
    "j": "о",
    "k": "л",
    "l": "д",
    ";": "ж",
    "'": "э",
    
    "Z": "Я",
    "X": "Ч",
    "C": "С",
    "V": "М",
    "B": "И",
    "N": "Т",
    "M": "Ь",    
    "<": "Б",
    ">": "Ю",
    "?": "Ё",    
    
    "z": "я",
    "x": "ч",
    "c": "с",
    "v": "м",
    "b": "и",
    "n": "т",
    "m": "ь",    
    ",": "б",
    ".": "ю",
    "/": "ё"
  };            
  
                     // Alphabet order
  var KbdVariant32 = {
    "~": "~",
    "!": "!",    
    "@": "@",
    "#": "#",
    "$": "$",
    "%": "%",
    "^": "^",
    "&": "&",
    "*": "*",
    "(": "(",
    ")": ")",
    "_": "_",
    "+": "+",
    
    "`": "`",
    "1": "1",
    "2": "2",
    "3": "3",
    "4": "4",
    "5": "5",
    "6": "6",
    "7": "7",
    "8": "8",
    "9": "9",
    "0": "0",
    "-": "-",    
    "=": "=",    
    
    "Q": "А",
    "W": "Б",
    "E": "В",
    "R": "Г",
    "T": "Д",
    "Y": "Е",
    "U": "Ё",
    "I": "Ж",
    "O": "З",
    "P": "И",
    "{": "И",
    "}": "К",
    "|": "|",
    
    "q": "а",
    "w": "б",
    "e": "в",
    "r": "г",
    "t": "д",
    "y": "е",
    "u": "ё",
    "i": "ж",
    "o": "з",
    "p": "и",
    "[": "й",
    "]": "к",
    "\\": "\\",
    
    "A": "Л",
    "S": "М",
    "D": "Н",
    "F": "О",
    "G": "П",
    "H": "Р",
    "J": "С",
    "K": "Т",
    "L": "У",
    ":": "Ф",
    "\"": "Х",
    
    "a": "л",
    "s": "м",
    "d": "н",
    "f": "о",
    "g": "п",
    "h": "р",
    "j": "с",
    "k": "т",
    "l": "у",
    ";": "ф",
    "'": "х",
    
    "Z": "Ц",
    "X": "Ч",
    "C": "Ш",
    "V": "Щ",
    "B": "Ъ",
    "N": "Ы",
    "M": "Ь",    
    "<": "Э",
    ">": "Ю",
    "?": "Я",    
    
    "z": "ц",
    "x": "ч",
    "c": "ш",
    "v": "щ",
    "b": "ъ",
    "n": "ы",
    "m": "ь",    
    ",": "э",
    ".": "ю",
    "/": "я"
  };          
  
                     // MS Standard йцукен - Ukrainian. Украинская стандартная - см.
                     // http://www.microsoft.com/globaldev/reference/keyboards.aspx

  var KbdVariant33 = {
    "~": "Ё",
    "!": "!",    
    "@": "\"",
    "#": "№",
    "$": ";",
    "%": "%",
    "^": ":",
    "&": "?",
    "*": "*",
    "(": "(",
    ")": ")",
    "_": "_",
    "+": "Ґ",
    
    "`": "ё",
    "1": "1",
    "2": "2",
    "3": "3",
    "4": "4",
    "5": "5",
    "6": "6",
    "7": "7",
    "8": "8",
    "9": "9",
    "0": "0",
    "-": "-",    
    "=": "ґ",    
    
    "Q": "Й",
    "W": "Ц",
    "E": "У",
    "R": "К",
    "T": "Е",
    "Y": "Н",
    "U": "Г",
    "I": "Ш",
    "O": "Щ",
    "P": "З",
    "{": "Х",
    "}": "Ї",
    "|": "/",
    
    "q": "й",
    "w": "ц",
    "e": "у",
    "r": "к",
    "t": "е",
    "y": "н",
    "u": "г",
    "i": "ш",
    "o": "щ",
    "p": "з",
    "[": "х",
    "]": "ї",
    "\\": "\\",
    
    "A": "Ф",
    "S": "І",
    "D": "В",
    "F": "А",
    "G": "П",
    "H": "Р",
    "J": "О",
    "K": "Л",
    "L": "Д",
    ":": "Ж",
    "\"": "Є",
    
    "a": "ф",
    "s": "і",
    "d": "в",
    "f": "а",
    "g": "п",
    "h": "р",
    "j": "о",
    "k": "л",
    "l": "д",
    ";": "ж",
    "'": "є",
    
    "Z": "Я",
    "X": "Ч",
    "C": "С",
    "V": "М",
    "B": "И",
    "N": "Т",
    "M": "Ь",    
    "<": "Б",
    ">": "Ю",
    "?": ",",    
    
    "z": "я",
    "x": "ч",
    "c": "с",
    "v": "м",
    "b": "и",
    "n": "т",
    "m": "ь",    
    ",": "б",
    ".": "ю",
    "/": "."
  };          
  


  var Pictures = {          
   '30': 'kbd/std_ru.png',                               
   '31': 'kbd/std_rutw.png',                              
   '32': 'kbd/alphabet.png',                              
   '33': 'kbd/std_ukr.png'                               
  };     
        

  var vkb_layoutTypeArrayNonUS = {
  '41':  'Slayouts',
  '61':  'Flayouts',
  '62':  'Flayouts',
  '42':  'Slayouts', 
  '71':  'Flayouts',
  '72':  'Flayouts',
  '73':  'Flayouts',
  '43':  'Slayouts',
  '81':  'Flayouts',
  '44':  'Slayouts',
  '91':  'Flayouts',
  '45':  'Slayouts',
  '101': 'Flayouts',
  '46':  'Slayouts',
  '111': 'Flayouts',
  '112': 'Flayouts',
  '47':  'Slayouts',
  '121': 'Flayouts',
  '122': 'Flayouts'
  };  

var vkb_optionArrayNonUS = {        
'41':  1,
'61':  1,
'62':  2,
'42':  1,
'71':  1,
'72':  2,
'73':  3,
'43':  1,
'81':  1,
'44':  1,
'91':  1,
'45':  1,
'101': 1,
'46':  1,
'111': 1,
'112': 2,
'47':  1,
'121': 1,
'122': 2
};

var vkb_optionKbdArrayNonUS = {        
'DE':  1,
'SV':  2,
'FR':  3,
'IT':  4,
'ES':  5,
'IL':  6,
'UK':  7
};




           
        
//////////////////////////////////////////////////////////
        
var ListName;
        
var RUSymbols = "АБВГДЕЁЖЗИЙКЛМНОПРСТУФХЦЧШЩЪЫЬЭЮЯабвгдеёжзийклмнопрстуфхцчшщъыьэюя";
        
var Show_ToLatin = false;
        
        
if (Opera)
 if (OperaVer >= 8) Br = "NN"; // Opera 8 works as Mozilla




var dotReplacement=null;

function changeKey (textControl, evt, keyChecker1)
{

   if (CyrFromKbd == 'Off' && KbdVariant != '888')  // regular latin editing
     return true;
  
   if (evt.ctrlKey || evt.metaKey || evt.altKey) // no "|| evt.shiftKey" - bad for Shift+letter typing
     return true;
      
  var keyChecker = eval(keyChecker1); // function name
  
  var keyCode = void 0;

  keyCode = evt.keyCode ? evt.keyCode :
               evt.charCode ? evt.charCode :
               evt.which ? evt.which : void 0;   

  if (evt.which == 0)
     return true;

  var CurrentKey; 

  if (keyCode)
     CurrentKey = String.fromCharCode(keyCode);

  var keyCheck = keyChecker(keyCode, CurrentKey);
  
  
  
   
  if (keyCode && window.event && !window.opera && !WebKitOK)   // IE
  {
        
    if (keyCheck.cancelKey)
      return false;
    else if (keyCheck.replaceKey)  
    {
      window.event.keyCode = keyCheck.newKeyCode;
      if (window.event.preventDefault)
          window.event.preventDefault();
      return true;
    }
    else
      return true;
  }
  else if (typeof textControl.setSelectionRange != 'undefined') // NN
  {
  
    if (keyCheck.cancelKey)
    {
      if (evt.preventDefault)
         evt.preventDefault();
      return false;
    }
    else if (keyCheck.replaceKey)
    {
 
      var oldSelectionStart = textControl.selectionStart;
      var oldSelectionEnd = textControl.selectionEnd;
      var selectedText = textControl.value.substring(oldSelectionStart, oldSelectionEnd);
      var newText = typeof keyCheck.newKey != 'undefined' ?
                    keyCheck.newKey : String.fromCharCode(keyCheck.newKeyCode);

      if ( Opera && (OperaVer >= 9) && (keyCode == 46 || keyCode == 35 || keyCode == 36) )
      {
          dotReplacement = newText;  // dot/Del or Home/# or End/$
          return true;
      }
      else dotReplacement = null;
                          

      // cancel the key event and insert the newKey for the current selection
      if (evt.preventDefault)
         evt.preventDefault();


      var scrollTop, scrollLeft;                                            
      if (textControl.type == 'textarea' && typeof textControl.scrollTop != 'undefined')
      {                                                        
         scrollTop  = textControl.scrollTop;                                 
         scrollLeft = textControl.scrollLeft;                               
      }                                                                     
      textControl.value =                                                   
               textControl.value.substring(0, oldSelectionStart) +          
               newText +                                                    
               textControl.value.substring(oldSelectionEnd);                
               
      if (typeof scrollTop != 'undefined')
      {                                
         textControl.scrollTop  = scrollTop;                                 
         textControl.scrollLeft = scrollLeft;                               
      }                                                                     
      textControl.setSelectionRange(oldSelectionStart + newText.length,     
                                    oldSelectionStart + newText.length);
      return false;
    }
    else
      return true;
  }          // Other browser:
  else if (keyCheck.cancelKey)
  {
    if (evt.preventDefault)
        evt.preventDefault();
    return false;
  }
  else
   return true;
}


function fIE (keyCode, CurrentKey) {
 
  
   if (CyrFromKbd == 'On')
   {
       var newKeyOut = eval("KbdVariant" + KbdVariant)[CurrentKey];
       if (newKeyOut)
         return { replaceKey: true, newKeyCode: newKeyOut.charCodeAt(), newKey: newKeyOut };    
       else
         return { cancelKey: false };
   }
   else
      return { cancelKey: false };
     
}
  // Copyright (c) 2005  Paul Gorodyansky http://WinRus.com http://Klava.WinRus.com
function fNN (keyCode, CurrentKey) {

  
   if (CyrFromKbd == 'On')
   { 
       var newKeyOut = eval("KbdVariant" + KbdVariant)[CurrentKey];
       if (newKeyOut)
         return { replaceKey: true, newKeyCode: keyCode, newKey: newKeyOut };
       else
         return { cancelKey: false };
   }
   else 
      return { cancelKey: false };
   
}

function fOther (keyCode, CurrentKey) {
 
  
   if (CyrFromKbd == 'On')
   {
      var newKeyOut = eval("KbdVariant" + KbdVariant)[CurrentKey];
      if (newKeyOut)
      {
         txtControl.value += newKeyOut;
         return { cancelKey: true };
      }
      else
         return { cancelKey: false };
   }
   else
      return { cancelKey: false };
     
}



/************ End of main, typing related code *************************************/

function Kbd_OnOff(form,ev)
{
   var mKey = ModeSwitchKeyPressed(ev);

   var swKeyPressed = false;
   
 if (WebKit) { if (mKey == 27) swKeyPressed = true; } // only Esc
 else
 {  
   if (Opera)
   {
     if (OperaVer < 8) {if (mKey == 27) swKeyPressed = true;}
     else {if (mKey == 117) swKeyPressed = true;}     
   }
   else {if (mKey == 27 || mKey == 123) swKeyPressed = true;} 
   
 }
  
   
   if (swKeyPressed)
   {
      if (typeof UseVirtKbd != 'undefined')
      {
         if (UseVirtKbd)
             switchMode(form);   
      }
      else
         switchMode(form);   
             
      if (Br == "IE")
         ev.returnValue=false;
   }    
}                       
                        // 17 - Ctrl, 123 - F12, 117 - F6, ESC - 27        
                        // IE - standard behavior for TEXTAREA - 
                        // remove all text if press Esc. Can be overridden, unlike Firefox and Opera 9:
                        // Firefox does the same, but only in <input type='text' and not in <textarea          
                        // Opera - since ver 9 - Esc: a) "deselect all" b) input field looses focus   
                        // Opera 7 - can not use F6. So in Opera 7 - use Esc, then from ver 8 - F6
                        // Google Chrome (WebKit) - only Esc as F12 and F6 are used by the browser

function ModeSwitchKeyPressed(ev)
{
  if (window.event) return window.event.keyCode
  else if (ev) return ev.which
       else return null;
}

                        
function switchMode(form)
{
  if (CyrFromKbd == 'Off')
  {
    CyrFromKbd = 'On';
    form.fromKbd[0].checked = true; // "On"
  }
  else
  {
    CyrFromKbd = 'Off';
    form.fromKbd[1].checked = true;  // "Off"
  }
  txtControl.focus();
}

function NewKbdPic(name,picture)
{
  if (KbdVariant == "888" && interfaceLanguage == 'E')
      picture = 'kbd/cyr-late.png';
      
  if (window.document.images) window.document.images[name].src = picture;
}

function SetVariant(myForm, sName, variant, PicTagName)
{
  var pic;
  if (variant.value == "0") {variant.value = KbdVariant; // txtControl.focus();
                             return false;}
  
  variant.selected = true;  KbdVariant = variant.value;  // txtControl.focus();
 
  if (KbdPhysical != "EN") // non-US
  {
     if (typeof JSnonUSwasLoaded != 'undefined')
     {
       if (JSnonUSwasLoaded)
       {
         nonUS_SetVariant(myForm, KbdVariant, PicTagName);
         
       }
     }
  }
  else
  { 
     pic = Pictures[KbdVariant];
     NewKbdPic(PicTagName, pic);
     
     
  }   

  
  
           
}          

function KbdPhysicalCalculate(num)  // non-US keyboard modes
{
  if (num < 60) // Standard 
  {
    switch (num)
    {                                                                           
      case 41:   KbdPhysical = "DE"; vkb_curImage = "kbd/std_de.png"; break;
      case 42:   KbdPhysical = "SV"; vkb_curImage = "kbd/std_sv.png"; break;
      case 43:   KbdPhysical = "FR"; vkb_curImage = "kbd/std_fr.png"; break;
      case 44:   KbdPhysical = "IT"; vkb_curImage = "kbd/std_it.png"; break;
      case 45:   KbdPhysical = "ES"; vkb_curImage = "kbd/std_es.png"; break;
      case 46:   KbdPhysical = "UK"; vkb_curImage = "kbd/std_uk.png"; break;            
      case 47:   KbdPhysical = "IL"; vkb_curImage = "kbd/std_il.png"; break;
      default: break;
    }      
  }
  else 
  {
    if (num < 70) {KbdPhysical = "DE"; if (num==61) vkb_curImage="kbd/german1.png"; else vkb_curImage="kbd/german2.png";}
    else if (num < 80) {KbdPhysical = "SV"; if (num==71) vkb_curImage="kbd/swedish1.png"; else if (num==72) vkb_curImage="kbd/swedish2.png"; else vkb_curImage="kbd/swedish3.png";}
         else if (num < 90) {KbdPhysical = "FR"; vkb_curImage="kbd/french1.png";}
              else if (num < 100) {KbdPhysical = "IT"; vkb_curImage="kbd/italian1.png";}    
                   else if (num < 110) {KbdPhysical = "ES"; vkb_curImage="kbd/spanish1.png";}        
                        else if (num < 120) {KbdPhysical = "UK"; if (num==111) vkb_curImage="kbd/british1.png"; else vkb_curImage="kbd/brit1ukr.png";}        
                             else if (num < 130) {KbdPhysical = "IL"; if (num==121) vkb_curImage="kbd/hebrew1.png"; else vkb_curImage="kbd/hebrew2.png";}    
  }
  
} 

           
           
function CopyText(box, parent_box)
{          
   var txt = parent_box.value + box.value;
           
   parent_box.value = txt;
   // parent_box.focus();
}          
           
function saveCaret(elem)
{          

  if ( elem.isTextEdit )
     elem.caretPos = document.selection.createRange();
    
  if (Opera && OperaVer >= 9 && dotReplacement != null)
  {
            var oldSelectionStart = elem.selectionStart;
            var oldSelectionEnd = elem.selectionEnd;
            var selectedText = elem.value.substring(oldSelectionStart, oldSelectionEnd);
            
            var str1 = elem.value.substring(0, oldSelectionStart);
            var sym = str1.substring(str1.length - 1);

            if (sym == "." || sym == "#" || sym == "$")
            {
               elem.value = elem.value.substring(0, oldSelectionStart-1) +          
                            dotReplacement +
                            elem.value.substring(oldSelectionEnd);                
               
               elem.setSelectionRange(oldSelectionStart, oldSelectionStart);
            }
            dotReplacement = null;
  }
}          
           
function insertAtCaret(textElement, newText)
{   
  if ( textElement.isTextEdit )
  { 
    if ( !textElement.caretPos )
    {
       saveCaret(textElement);       
    }
    
    var caretPos = textElement.caretPos;
    caretPos.text = newText;
    caretPos.select(); 
  } 
}   



var ENSymbols = "~!@#$%^&*()_+QWERTYUIOP{}|ASDFGHJKL:\"/|ZXCVBNM<>?`1234567890-=qwertyuiop[]\\asdfghjkl;'\\\\zxcvbnm,./";
//var ENSymbols = "~!@#$%^&*()_+`1234567890-=QWERTYUIOP{}|qwertyuiop[]\\ASDFGHJKL:\"asdfghjkl;'ZXCVBNM<>?zxcvbnm,./";
 
var Mouse30 = "Ё!\"№;%:?*()_+ЙЦУКЕНГШЩЗХЪ/ФЫВАПРОЛДЖЭ/|ЯЧСМИТЬБЮ,ё1234567890-=йцукенгшщзхъ\\фывапролджэ\\\\ячсмитьбю.";
var Mouse31 = "+1234567890=\\ЙЦУКЕНГШЩЗХЪ(ФЫВАПРОЛДЖЭ(|ЯЧСМИТЬБЮЁ|№-/\":,._?%!;йцукенгшщзхъ)фывапролджэ)\\ячсмитьбюё";
var Mouse32 = "~!@#$%^&*()_+АБВГДЕЁЖЗИЙК|ЛМНОПРСТУФХ||ЦЧШЩЪЫЬЭЮЯ`1234567890-=абвгдеёжзийк\\лмнопрстуфх\\\\цчшщъыьэюя";
var Mouse33 = "Ё!\"№;%:?*()_ҐЙЦУКЕНГШЩЗХЇ/ФІВАПРОЛДЖЄ/ҐЯЧСМИТЬБЮ,ё1234567890-ґйцукенгшщзхї\\фівапролджє\\ґячсмитьбю.";
var Mouse34 = "Ё!\"№;%:?*()_+ЙЦУКЕНГШЩЗХЪ/ФЫВАПРОЛДЖЭ/>ЯЧСМИТЬБЮ,ё1234567890-=йцукенгшщзхъ\\фывапролджэ\\<ячсмитьбю.";

             

function fromAlphabet(LetNumber, evt)
{
  var CurrentKey; 
  if (  KbdVariant != 888  )
  {
    var ListName;
    if (KbdVariant < 60 && KbdVariant > 40)  // non-US: std_ru layout for larger physical keyboard is the same for every language
    {
      if (KbdPhysical == "UK")       // |\ on the button in the bottom left
         ListName = Mouse30;
      else                           // <> on the button in the bottom left
         ListName = Mouse34;
    } 
    else
     ListName = eval("Mouse" + KbdVariant);
     
    var ShiftNum = 49;
        
    if (evt.shiftKey)
        CurrentKey =  ListName.charAt(LetNumber);
    else
        CurrentKey =  ListName.charAt(LetNumber+ShiftNum);
    
    txtControl.focus();

    if (Br == "NN")
    {
       if (typeof txtControl.setSelectionRange != 'undefined')
       {
         var oldSelectionStart = txtControl.selectionStart;
         var oldSelectionEnd = txtControl.selectionEnd;
         var selectedText = txtControl.value.substring(oldSelectionStart, oldSelectionEnd);
         var newText = CurrentKey;
         
         var scrollTop, scrollLeft;                                            
         if (txtControl.type == 'textarea' &&                                  
             typeof txtControl.scrollTop != 'undefined')                       
         {                                                                     
            scrollTop  = txtControl.scrollTop;                                 
            scrollLeft = txtControl.scrollLeft;  
         }                                                                     
         txtControl.value =                                                                                 
                  txtControl.value.substring(0, oldSelectionStart) +                                        
                  newText +                                                                                 
                  txtControl.value.substring(oldSelectionEnd);                                              
                                                                                                            
         if (typeof scrollTop != 'undefined')                                                               
         {                                                                                                  
            txtControl.scrollTop  = scrollTop;                                                              
            txtControl.scrollLeft = scrollLeft;                                                            
         }                                                                                                  
         txtControl.setSelectionRange(oldSelectionStart + newText.length,                                   
                                      oldSelectionStart + newText.length);                                  
       }
    }
    else if (Br == "IE")
         { 
            insertAtCaret(txtControl,CurrentKey);
         }
         else
            txtControl.value += CurrentKey;
   } 
}

               
               
  

function findPosX(obj)
{
	var curleft = 0;
	if (obj.offsetParent)
	{
		while (obj.offsetParent)
		{
			curleft += obj.offsetLeft
			obj = obj.offsetParent;
		}
	}
	else if (obj.x)
		curleft += obj.x;
	return curleft;
}

function findPosY(obj)
{
	var curtop = 0;
	if (obj.offsetParent)
	{
		while (obj.offsetParent)
		{
			curtop += obj.offsetTop
			obj = obj.offsetParent;
		}
	}
	else if (obj.y)
		curtop += obj.y;
	return curtop;
}

/////////////////////////////////////////////////////////////
// Extended Tooltip Javascript:
// copyright 9th August 2002, 3rd July 2005
// by Stephen Chapman, Felgall Pty Ltd
//
// Paul G: Modified, it was no choice: z-index in IE does not work with form's selection elements,
// so if they are under my mapped image, then tooltip's text is behind Selection elements
// Had to show tooltips always at the same position related to my image, where
// there are no Selection elements on the way
var DH = 0;var an = 0;var al = 0;var ai = 0;if (document.getElementById) {ai = 1; DH = 1;}else {if (document.all) {al = 1; DH = 1;} else { browserVersion = parseInt(navigator.appVersion); if ((navigator.appName.indexOf('Netscape') != -1) && (browserVersion == 4)) {an = 1; DH = 1;}}} function fd(oi, wS) {if (ai) return wS ? document.getElementById(oi).style:document.getElementById(oi); if (al) return wS ? document.all[oi].style: document.all[oi]; if (an) return document.layers[oi];}
function pw() {return window.innerWidth != null? window.innerWidth: document.body.clientWidth != null? document.body.clientWidth:null;}
function mouseX(evt) {if (evt.pageX) return evt.pageX; else if (evt.clientX)return evt.clientX + (document.documentElement.scrollLeft ?  document.documentElement.scrollLeft : document.body.scrollLeft); else return null;}
function mouseY(evt) {if (evt.pageY) return evt.pageY; else if (evt.clientY)return evt.clientY + (document.documentElement.scrollTop ? document.documentElement.scrollTop : document.body.scrollTop); else return null;}
function popUp(evt,oi,elID, t,l) {
        if (KbdVariant == '888') return; 
        var diff=0;
        if (Br == 'IE' && !Opera) diff=60; else if (Opera) diff=-50; else if(WebKit) diff=20;
        var myObj=document.getElementById(elID);
        var toppos = findPosY(myObj)+ (t) +(diff);
        var leftpos = findPosX(myObj)+ (l);
        
        if (DH) {var wp = pw(); ds = fd(oi,1); dm = fd(oi,0); st = ds.visibility; if (dm.offsetWidth) ew = dm.offsetWidth; else if (dm.clip.width) ew = dm.clip.width; if (st == "visible" || st == "show") { ds.visibility = "hidden"; } else {tv = toppos + 20; lv = leftpos - (ew/4); if (lv < 2) lv = 2; else if (lv + ew > wp) lv -= ew/2; if (!an) {lv += 'px';tv += 'px';} ds.left = lv; ds.top = tv; ds.visibility = "visible";}}
        // if (DH) {var wp = pw(); ds = fd(oi,1); dm = fd(oi,0); st = ds.visibility; if (dm.offsetWidth) ew = dm.offsetWidth; else if (dm.clip.width) ew = dm.clip.width; if (st == "visible" || st == "show") { ds.visibility = "hidden"; } else {tv = mouseY(evt) + 20; lv = mouseX(evt) - (ew/4); if (lv < 2) lv = 2; else if (lv + ew > wp) lv -= ew/2; if (!an) {lv += 'px';tv += 'px';} ds.left = lv; ds.top = tv; ds.visibility = "visible";}}
}
/////////////////////////////////////////////////////////////


function copy_clip(myText){
// based on example at http://www.webdeveloper.com/forum/showpost.php?p=344728&postcount=10
	if (window.clipboardData)
           window.clipboardData.setData("Text", myText);
	else if (window.netscape){
		netscape.security.PrivilegeManager.enablePrivilege  ('UniversalXPConnect');

		var clip = Components.classes['@mozilla.org/widget/clipboard;1'].createInstance(Components.interfaces.nsIClipboard  );
		if (!clip) return false;

		var trans = Components.classes['@mozilla.org/widget/transferable;1'].createInstance(Components.interfaces.nsITransferable);
		if (!trans) return false;

		trans.addDataFlavor('text/unicode');

		var str = new Object();
		var len = new Object();

		var str = Components.classes["@mozilla.org/supports-string;1"].createInstance(Components.interfaces.nsISupportsString);   
		var copytext=myText;   
		str.data=copytext;   
		trans.setTransferData("text/unicode",str,copytext.length*2);   
		var clipid=Components.interfaces.nsIClipboard;

		if (!clip) return false;   
		clip.setData(trans,null,clipid.kGlobalClipboard);

	}

	return false;
}



function PasteIE()
{
     var range = txtControl.createTextRange(); 
     range.execCommand("Paste"); 
}
function CopyIE()
{
     var range = txtControl.createTextRange(); 
     range.execCommand("Copy"); 
}
function ClearIE()
{
     var range = txtControl.createTextRange(); 
     range.execCommand("Delete"); 
}


JSwasLoaded = true;




